package away3d.core.stats 
{
    
    import flash.ui.ContextMenu;
    import flash.ui.ContextMenuItem;
    import flash.ui.ContextMenuBuiltInItems;
    import flash.events.ContextMenuEvent;
    import flash.display.Sprite;
    import flash.text.TextField;
    import flash.text.TextFormat;
    import flash.text.TextFieldAutoSize;
    import flash.display.Stage;
    import flash.geom.Matrix;
    import flash.geom.Rectangle;
    import flash.geom.Point;
    import flash.geom.ColorTransform;
    import flash.net.*;
    import flash.events.*;
    import flash.display.Graphics;
    import flash.system.System;
    import flash.utils.*;
    
    import away3d.core.scene.*;
    
    public class Stats extends Sprite
    {
        public static var instance:Stats = new Stats();
        private static var oStats:Object = new Object();
        private static var totalFaces:int = 0;
        private static var meshes:int = 0;
        private static var aTypes:Array = new Array();
        private static var contextmenu:ContextMenu;
        public static var scopeMenu:View3D = null;
        public static var scopeMenuRegion:Sprite = null;
        public static var displayMenu:Sprite = null;
        public static var geomMenu:Sprite = null;
        public static var stage:Stage;
        private static var lastrender:int;
        private static var fpsLabel:TextField;
        private static var titleField:TextField;
        private static var perfLabel:TextField;
        private static var ramLabel:TextField;
        private static var swfframerateLabel:TextField;
        private static var avfpsLabel:TextField;
        private static var peakLabel:TextField;
        private static var faceLabel:TextField;
        private static var faceRenderLabel:TextField;
        private static var geomDetailsLabel:TextField;
        private static var meshLabel:TextField;
        private static var fpstotal:int = 0;
        private static var refreshes:int = 0;
        private static var bestfps:int = 0;
        private static var lowestfps:int = 999;
        private static var bar:Sprite;
        private static var barwidth:int = 0;
        private static var closebtn:Sprite;
        private static var cambtn:Sprite;
        private static var clearbtn:Sprite;
        private static var geombtn:Sprite;
        private static var maxminbtn:Sprite;
        private static var barscale:int = 0;
        private static var stageframerate:Number;
        private static var displayState:int;
        private static var camLabel:TextField;
        private static var camMenu:Sprite;
        private static var camProp:Array;
        private static var rectclose:Rectangle = new Rectangle(228,4,18,17);
        private static var rectcam:Rectangle = new Rectangle(207,4,18,17);
        private static var rectclear:Rectangle = new Rectangle(186,4,18,17);
        private static var rectdetails:Rectangle = new Rectangle(165,4,18,17);
        private static var geomLastAdded:String;
        private static var defautTF:TextFormat = new TextFormat("Verdana", 10, 0x000000);
        //
        private static const VERSION:String = "1";
        private static const REVISION:String = "9.0.0";
        private static const APPLICATION_NAME:String = "Away3D.com";
        
        public function Stats()
        {
        }
        
        public function generateMenu(scope:View3D, stage:Stage, stageframerate:Number = 0):void
        {
            Stats.scopeMenu = scope;
            Stats.contextmenu = new ContextMenu();
            Stats.stageframerate = (stageframerate == 0)? 30 : stageframerate;
            Stats.stage = stage;
            Stats.displayState = 0;
            var menutitle:String = Stats.APPLICATION_NAME+"\tv" + Stats.VERSION +"."+Stats.REVISION;
            var menu:ContextMenuItem = new ContextMenuItem(menutitle, true, true, true);
            var menu2:ContextMenuItem = new ContextMenuItem("Away3D Project stats", true, true, true);
            var menu3:ContextMenuItem = new ContextMenuItem(" ");
            Stats.contextmenu.customItems = [menu2, menu, menu3];
            menu.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, visitWebsite);
            menu2.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, displayStats);
            Stats.scopeMenu.contextMenu = Stats.contextmenu;
        }
        
        //Redirect to site
        public function visitWebsite(e:ContextMenuEvent):void 
        {
            var url:String = "http://www.away3d.com";
            var request:URLRequest = new URLRequest(url);
            try {
                navigateToURL(request);
            } catch (e:Error) {
                
            }
        }
        //Displays stats
        public function displayStats(e:ContextMenuEvent):void
        {
             if(!Stats.displayMenu){
                generateSprite();
                addEventMouse();
                //applyShadow();
             }
        }
        
        //Closes stats and cleans up a bit...
        private function closeStats():void
        { 
            Stats.displayState = 0;
            Stats.scopeMenu.removeEventListener(StatsEvent.RENDER, updateFPS);
            Stats.scopeMenu.removeEventListener(MouseEvent.MOUSE_DOWN, onCheckMouse);
            Stats.scopeMenu.removeEventListener(MouseEvent.MOUSE_MOVE, updateTips);
            Stats.scopeMenu.removeChild(Stats.displayMenu);
            Stats.displayMenu = null;
        }
        
        //Mouse Events
        private function addEventMouse():void
        {  
            Stats.scopeMenu.addEventListener(MouseEvent.MOUSE_DOWN, onCheckMouse);
            Stats.scopeMenu.addEventListener(MouseEvent.MOUSE_MOVE, updateTips);
        }
        
        private function updateTips(me:MouseEvent):void
        { 
            if(Stats.scopeMenu != null){
                var x:Number = Stats.displayMenu.mouseX;
                var y:Number = Stats.displayMenu.mouseY;
                var pt:Point = new Point(x,y);
                try {
                    if(Stats.rectcam.containsPoint(pt)){
                        Stats.titleField.text = "CAMERA INFO";
                    } else if(Stats.rectclose.containsPoint(pt)){
                        Stats.titleField.text = "CLOSE STATS";
                    } else if(Stats.rectclear.containsPoint(pt)){
                        Stats.titleField.text = "CLEAR AVERAGES";
                    } else if(Stats.rectdetails.containsPoint(pt)){
                        Stats.titleField.text = "MESH INFO";
                    } else{
                        Stats.titleField.text = "AWAY3D PROJECT";
                    }
                } catch (e:Error) {
                    
                }
            }
        }
        
        
        private function onCheckMouse(me:MouseEvent):void
        { 
            var x:Number = Stats.displayMenu.mouseX;
            var y:Number = Stats.displayMenu.mouseY;
            var pt:Point = new Point(x,y);
            
            if(Stats.rectcam.containsPoint(pt)){
                if(Stats.displayState != 1){
                    closeOtherScreen(Stats.displayState);
                    Stats.displayState = 1;
                    showCamInfo();
                } else{
                    Stats.displayState = 0;
                    hideCamInfo();
                }
            } else if(Stats.rectdetails.containsPoint(pt)){
                if(Stats.displayState != 2){
                    closeOtherScreen(Stats.displayState);
                    Stats.displayState = 2;
                    showGeomInfo();
                } else{
                    Stats.displayState = 0;
                    hideGeomInfo();
                }
            } else if(Stats.rectclose.containsPoint(pt)){
                closeStats();
            } else if(Stats.rectclear.containsPoint(pt)){
                clearStats();
            } else{
                Stats.displayMenu.startDrag();
                Stats.scopeMenu.addEventListener(MouseEvent.MOUSE_UP, mouseReleased);
            }
        }
        
        private function closeOtherScreen(actual:int):void {
             switch(actual){
                case 1:
                hideCamInfo();
                break;
                case 2:
                hideGeomInfo();
             }
        }
        
        private function mouseReleased(event:MouseEvent):void {
            Stats.displayMenu.stopDrag();
            Stats.scopeMenu.removeEventListener(MouseEvent.MOUSE_UP, mouseReleased);
        }
        
        //drawing the stats container
        private function generateSprite():void
        {  
          
            Stats.displayMenu = new Sprite();
            var myMatrix:Matrix = new Matrix();
            myMatrix.rotate(90 * Math.PI/180); 
            Stats.displayMenu.graphics.beginGradientFill("linear", [0x333366, 0xCCCCCC], [1,1], [0,255], myMatrix, "pad", "rgb", 0);
            Stats.displayMenu.graphics.drawRect(0, 0, 250, 86);
            
            Stats.displayMenu.graphics.beginFill(0x333366);
            Stats.displayMenu.graphics.drawRect(3, 3, 244, 20);
             
            Stats.scopeMenu.addChild(Stats.displayMenu);
             
            Stats.displayMenu.x -= Stats.displayMenu.width*.5;
            Stats.displayMenu.y -= Stats.displayMenu.height*.5;
            
            // generate closebtn
            Stats.closebtn = new Sprite();
            Stats.closebtn.graphics.beginFill(0x666666);
            Stats.closebtn.graphics.drawRect(0, 0, 18, 17);
            var cross:Sprite = new Sprite();
            cross.graphics.beginFill(0xC6D0D8);
            cross.graphics.drawRect(2, 7, 14, 4);
            cross.graphics.endFill();
            cross.graphics.beginFill(0xC6D0D8);
            cross.graphics.drawRect(7, 2, 4, 14);
            cross.graphics.endFill();
            cross.rotation = 45;
            cross.x+=9;
            cross.y-=4;
            Stats.closebtn.addChild(cross);
            Stats.displayMenu.addChild(Stats.closebtn);
            Stats.closebtn.x = 228;
            Stats.closebtn.y = 4;
            
            // generate cam btn
            Stats.cambtn = new Sprite();
            var cam:Graphics = Stats.cambtn.graphics;
            cam.beginFill(0x666666);
            cam.drawRect(0, 0, 18, 17);
            cam.endFill();
            cam.beginFill(0xC6D0D8);
            cam.moveTo(10,8);
            cam.lineTo(16,4);
            cam.lineTo(16,14);
            cam.lineTo(10,10);
            cam.lineTo(10,8);
            cam.drawRect(2, 6, 8, 6);
            cam.endFill();
            Stats.displayMenu.addChild(Stats.cambtn);
            Stats.cambtn.x = 207;
            Stats.cambtn.y = 4;
            
            // generate clear btn
            Stats.clearbtn = new Sprite();
            var clear_btn:Graphics = Stats.clearbtn.graphics;
            clear_btn.beginFill(0x666666);
            clear_btn.drawRect(0, 0, 18, 17);
            clear_btn.endFill();
            clear_btn.beginFill(0xC6D0D8);
            clear_btn.drawRect(6, 6, 6, 6);
            clear_btn.endFill();
            Stats.displayMenu.addChild(Stats.clearbtn);
            Stats.clearbtn.x = 186;
            Stats.clearbtn.y = 4;
            
            // generate geometrie btn
            Stats.geombtn = new Sprite();
            var geom_btn:Graphics = Stats.geombtn.graphics;
            geom_btn.beginFill(0x666666);
            geom_btn.drawRect(0, 0, 18, 17);
            geom_btn.endFill();
            geom_btn.beginFill(0xC6D0D8, 0.7);
            geom_btn.moveTo(3,4);
            geom_btn.lineTo(11,2);
            geom_btn.lineTo(16,5);
            geom_btn.lineTo(7,7);
            geom_btn.lineTo(3,4);
            geom_btn.beginFill(0x7D8489, 0.8);
            geom_btn.moveTo(3,4);
            geom_btn.lineTo(7,7);
            geom_btn.lineTo(7,16);
            geom_btn.lineTo(3,12);
            geom_btn.lineTo(3,4);
            geom_btn.beginFill(0xC6D0D8,1);
            geom_btn.moveTo(7,7);
            geom_btn.lineTo(16,5);
            geom_btn.lineTo(15,13);
            geom_btn.lineTo(7,16);
            geom_btn.lineTo(7,7);
            geom_btn.endFill();
             
            geom_btn.endFill();
            Stats.displayMenu.addChild(Stats.geombtn);
            Stats.geombtn.x = 165;
            Stats.geombtn.y = 4;
            
            // generate bar
            Stats.displayMenu.graphics.beginGradientFill("linear", [0x000000, 0xFFFFFF], [1,1], [0,255], new Matrix(), "pad", "rgb", 0);
            Stats.displayMenu.graphics.drawRect(3, 22, 244, 4);
            Stats.displayMenu.graphics.endFill();
            Stats.bar = new Sprite();
            Stats.bar.graphics.beginFill(0xFFFFFF);
            Stats.bar.graphics.drawRect(0, 0, 244, 4);
            Stats.displayMenu.addChild(Stats.bar);
            Stats.bar.x = 3;
            Stats.bar.y = 22;
            Stats.barwidth = 244;
            Stats.barscale = int(Stats.barwidth/Stats.stageframerate);
            
            // displays Away logo
            displayPicto();
            
            // Generate textfields
            // title
            Stats.titleField = new TextField();
            Stats.titleField.defaultTextFormat = new TextFormat("Verdana", 10, 0xFFFFFF, true, null,null,null,null,"left");
            Stats.titleField.text = "AWAY3D PROJECT";
            Stats.titleField.height = 20;
            Stats.titleField.width = 200;
            Stats.titleField.x = 22;
            Stats.titleField.y = 4;
            Stats.displayMenu.addChild(Stats.titleField);
            
            // fps
            var fpst:TextField = new TextField();
            fpst.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            fpst.text = "FPS:";
            Stats.fpsLabel = new TextField();
            Stats.fpsLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(fpst);
            Stats.displayMenu.addChild(Stats.fpsLabel);
            fpst.x = 3;
            fpst.y = Stats.fpsLabel.y = 30;
            fpst.autoSize = "left";
            Stats.fpsLabel.x = fpst.x+fpst.width-2;
            
            //average perf
            var afpst:TextField = new TextField();
            afpst.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            afpst.text = "AFPS:";
            Stats.avfpsLabel = new TextField();
            Stats.avfpsLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(afpst);
            Stats.displayMenu.addChild(Stats.avfpsLabel);
            afpst.x = 52;
            afpst.y = Stats.avfpsLabel.y = Stats.fpsLabel.y;
            afpst.autoSize = "left";
            Stats.avfpsLabel.x = afpst.x+afpst.width-2;
            
            //Max peak
            var peakfps:TextField = new TextField();
            peakfps.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            peakfps.text = "Max:";
            Stats.peakLabel = new TextField();
            Stats.peakLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(peakfps);
            Stats.displayMenu.addChild(Stats.peakLabel);
            peakfps.x = 107;
            peakfps.y = Stats.peakLabel.y = Stats.avfpsLabel.y;
            peakfps.autoSize = "left";
            Stats.peakLabel.x = peakfps.x+peakfps.width-2;
            
            //MS
            var pfps:TextField = new TextField();
            pfps.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            pfps.text = "MS:";
            Stats.perfLabel = new TextField();
            Stats.perfLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(pfps);
            Stats.displayMenu.addChild(Stats.perfLabel);
            pfps.x = 177;
            pfps.y = Stats.perfLabel.y = Stats.fpsLabel.y;
            pfps.autoSize = "left";
            Stats.perfLabel.x = pfps.x+pfps.width-2;
             
            //ram usage
            var ram:TextField = new TextField();
            ram.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            ram.text = "RAM:";
            Stats.ramLabel = new TextField();
            Stats.ramLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(ram);
            Stats.displayMenu.addChild(Stats.ramLabel);
            ram.x = 3;
            ram.y = Stats.ramLabel.y = 46;
            ram.autoSize = "left";
            Stats.ramLabel.x = ram.x+ram.width-2;
            
            //meshes count
            var meshc:TextField = new TextField();
            meshc.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            meshc.text = "MESHES:";
            Stats.meshLabel = new TextField();
            Stats.meshLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(meshc);
            Stats.displayMenu.addChild(Stats.meshLabel);
            meshc.x = 70;
            meshc.y = Stats.meshLabel.y = Stats.ramLabel.y;
            meshc.autoSize = "left";
            Stats.meshLabel.x = meshc.x+meshc.width-2;
            
            //swf framerate
            var rate:TextField = new TextField();
            rate.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            rate.text = "SWF FR:";
            Stats.swfframerateLabel = new TextField();
            Stats.swfframerateLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(rate);
            Stats.displayMenu.addChild(Stats.swfframerateLabel);
            rate.x = 170;
            rate.y = Stats.swfframerateLabel.y = Stats.ramLabel.y;
            rate.autoSize = "left";
            Stats.swfframerateLabel.x = rate.x+rate.width-2;
            
            //faces
            var faces:TextField = new TextField();
            faces.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            faces.text = "FACES:";
            Stats.faceLabel = new TextField();
            Stats.faceLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(faces);
            Stats.displayMenu.addChild(Stats.faceLabel);
            faces.x = 3;
            faces.y = Stats.faceLabel.y = 62;
            faces.autoSize = "left";
            Stats.faceLabel.x = faces.x+faces.width-2;
            
            //shown faces
            var facesrender:TextField = new TextField();
            facesrender.defaultTextFormat = new TextFormat("Verdana", 10, 0x000000, true);
            facesrender.text = "RFACES:";
            Stats.faceRenderLabel = new TextField();
            Stats.faceRenderLabel.defaultTextFormat = Stats.defautTF
            Stats.displayMenu.addChild(facesrender);
            Stats.displayMenu.addChild(Stats.faceRenderLabel);
            facesrender.x = 95;
            facesrender.y = Stats.faceRenderLabel.y = Stats.faceLabel.y;
            facesrender.autoSize = "left";
            Stats.faceRenderLabel.x = facesrender.x+facesrender.width-2;
            
            // ok lets fill some info here
            Stats.scopeMenu.addEventListener(StatsEvent.RENDER, updateFPS); 
             
        }
        
        private function updateFPS(e:StatsEvent):void
        {
            var now:int = getTimer();
            var perf:int = now - Stats.lastrender;
            Stats.lastrender = now;
            
            if (perf < 1000) {
                var fps:int = int(1000 / (perf+0.001));
                Stats.fpstotal += fps;
                Stats.refreshes ++;
                var average:int = fpstotal/refreshes;
                Stats.bestfps = (fps>Stats.bestfps)? fps : Stats.bestfps;
                Stats.lowestfps = (fps<Stats.lowestfps)? fps : Stats.lowestfps;
                var w:int = Stats.barscale*fps;
                Stats.bar.width = (w<=Stats.barwidth)? w : Stats.barwidth;
            }
            //color
            var procent:int = (Stats.bar.width/Stats.barwidth)*100;
            var colorTransform:ColorTransform = Stats.bar.transform.colorTransform;
            colorTransform.color =  255-(2.55*procent) << 16 | 2.55*procent << 8 | 40;
            Stats.bar.transform.colorTransform = colorTransform;
                
            if(Stats.displayState == 0){
                Stats.avfpsLabel.text = ""+average;
                Stats.ramLabel.text = ""+int(System.totalMemory/1024/1024)+"MB";
                Stats.peakLabel.text = Stats.lowestfps+"/"+Stats.bestfps;
                Stats.fpsLabel.text = "" + fps; 
                Stats.perfLabel.text = "" + perf;
                Stats.faceLabel.text = ""+Stats.totalFaces;
                Stats.faceRenderLabel.text = ""+e.totalfaces;
                Stats.meshLabel.text = ""+Stats.meshes;
                Stats.swfframerateLabel.text = ""+Stats.stageframerate;
            } else if(Stats.displayState == 1){
                var caminfo:String = "";
                for(var i:int = 0;i<Stats.camProp.length;i++){
                    try{
                        if(i>12){
                            caminfo += String(e.camera[Stats.camProp[i]])+"\n";
                        } else {
                            var info:String = String(e.camera[Stats.camProp[i]]);
                            caminfo += info.substring(0, 19)+"\n";
                        }
                    } catch(e:Error){
                        caminfo += "\n";
                    }
                }
                Stats.camLabel.text = caminfo;
            } else if(Stats.displayState == 2){
                Stats.geomDetailsLabel.appendText(lastRegister);
                Stats.geomDetailsLabel.scrollV = Stats.geomDetailsLabel.maxScrollV;
            }
            
        }
        
        //clear peaks
        private function clearStats():void
        {
            Stats.fpstotal = 0;
            Stats.refreshes = 0;
            Stats.bestfps = 0;
            Stats.lowestfps = 999;
        }
        
        //geometrie info
        private function showGeomInfo():void
        {
            if(Stats.geomMenu == null){
                createGeometrieMenu();
            } else{
                Stats.displayMenu.addChild(Stats.geomMenu);
                Stats.geomMenu.y = 26;
            }
        }
        
        private function hideGeomInfo():void
        {   
            if(Stats.geomMenu != null){
                Stats.displayMenu.removeChild(Stats.geomMenu);
            }
        }
        private function createGeometrieMenu():void{
            Stats.geomMenu = new Sprite();
            var myMatrix:Matrix = new Matrix();
            myMatrix.rotate(90 * Math.PI/180);
            Stats.geomMenu.graphics.beginGradientFill("linear", [0x333366, 0xCCCCCC], [1,1], [0,255], myMatrix, "pad", "rgb", 0);
            Stats.geomMenu.graphics.drawRect(0, 0, 250, 200);
            Stats.displayMenu.addChild(Stats.geomMenu);
            Stats.geomMenu.y = 26;
            Stats.geomDetailsLabel = new TextField();
            Stats.geomDetailsLabel.x = 3;
            Stats.geomDetailsLabel.y = 3;
            Stats.geomDetailsLabel.defaultTextFormat = Stats.defautTF
            Stats.geomDetailsLabel.text = stats;
            Stats.geomDetailsLabel.height = 200;
            Stats.geomDetailsLabel.width = 235;
            Stats.geomDetailsLabel.multiline = true;
            Stats.geomDetailsLabel.selectable = true;
            Stats.geomDetailsLabel.wordWrap = true;
            Stats.geomMenu.addChild(Stats.geomDetailsLabel);
        }
        
        //cam info
        private function showCamInfo():void
        {
            if(Stats.camMenu == null){
                createCamMenu();
            } else{
                Stats.displayMenu.addChild(Stats.camMenu);
                Stats.camMenu.y = 26;
            }
        }
        
        private function hideCamInfo():void
        {   
            if(Stats.camMenu != null){
                Stats.displayMenu.removeChild(Stats.camMenu);
            }
        }
        
        // cam info menu
        private function createCamMenu():void
        {   
            Stats.camMenu = new Sprite();
            var myMatrix:Matrix = new Matrix();
            myMatrix.rotate(90 * Math.PI/180);
            Stats.camMenu.graphics.beginGradientFill("linear", [0x333366, 0xCCCCCC], [1,1], [0,255], myMatrix, "pad", "rgb", 0);
            Stats.camMenu.graphics.drawRect(0, 0, 250, 220);
            Stats.displayMenu.addChild(Stats.camMenu);
            Stats.camMenu.y = 26;
            Stats.camLabel = new TextField();
            Stats.camLabel.height = 210;
            Stats.camLabel.width = 170;
            Stats.camLabel.x = 100;
            Stats.camLabel.multiline = true;
            var tf:TextFormat = Stats.defautTF
            tf.leading = 1.5;
            Stats.camLabel.defaultTextFormat = tf;
            Stats.camLabel.wordWrap = true;
            Stats.camMenu.addChild(Stats.camLabel);
            Stats.camLabel.x = 100;
            Stats.camLabel.y = 3;
            Stats.camProp = ["x","y","z","zoom","focus","distance","panangle","tiltangle","targetpanangle","targettiltangle","mintiltangle","maxtiltangle","steps","target"];
            //props
            var campropfield:TextField = new TextField();
            tf = new TextFormat("Verdana", 10, 0x000000, true);
            tf.leading = 1.5;
            tf.align = "right";
            campropfield.defaultTextFormat = tf;
            campropfield.x = campropfield.y = 3;
            campropfield.multiline = true;
            campropfield.selectable = false;
            campropfield.autoSize = "left";
            campropfield.height = 210;
            for(var i:int = 0;i<Stats.camProp.length;i++){ 
                campropfield.appendText(Stats.camProp[i]+":\n");
            }
            Stats.camMenu.addChild(campropfield);
        }
        
        private function displayPicto():void
        {
            var logo:Sprite = new Sprite();
            var graphic:Graphics = logo.graphics;
            //graphic.beginFill(0x666666);
            graphic.beginFill(0x000000);
            graphic.drawRect(0, 0, 18, 17);
            var arr:Array = image;
            for(var i:int = 0;i<arr.length;i++){
                graphic.beginFill(Number(arr[i][2]));
                graphic.drawRect(arr[i][0], arr[i][1], 1, 1);
            }
            
            graphic.endFill();
            Stats.displayMenu.addChild(logo);
            logo.x = logo.y = 4;
        }
        private function get image():Array
        {
            return [[7,1,262151],[8,1,3215136],[9,1,2033436],[10,1,1],[7,2,2098723],[8,2,5908501],[9,2,4922400],[10,2,720913],[6,3,327691],[7,3,6957102],[8,3,5975556],[9,3,6368779],[10,3,4789809],[11,3,2],[6,4,2361127],[7,4,10833686],[8,4,4926728],[9,4,6239495],[10,4,9190690],[11,4,1114647],[5,5,786453],[6,5,7088423],[7,5,14055707],[8,5,2103310],[9,5,3877139],[10,5,13134098],[11,5,5577773],[12,5,131077],[4,6,1],[5,6,3608110],[6,6,11227664],[7,6,12748351],[8,6,65793],[9,6,986379],[10,6,14980667],[11,6,10044437],[12,6,2230306],[4,7,1179676],[5,7,8007967],[6,7,14911011],[7,7,6509633],[10,7,9138771],[11,7,13989655],[12,7,7350824],[13,7,327689],[3,8,262153],[4,8,4592689],[5,8,12016138],[6,8,15774570],[7,8,855309],[10,8,2434083],[11,8,16233056],[12,8,11489803],[13,8,3345958],[3,9,1966887],[4,9,8665113],[5,9,15636021],[6,9,6773581],[11,9,9140836],[12,9,15240489],[13,9,8467743],[14,9,852240],[2,10,458767],[3,10,5774639],[4,10,13265683],[5,10,10845518],[6,10,257],[11,10,657931],[12,10,14396016],[13,10,12739344],[14,10,5184297],[15,10,2],[2,11,2557230],[3,11,10307863],[4,11,12548133],[5,11,723464],[12,11,1512721],[13,11,14651446],[14,11,10307352],[15,11,1508630],[1,12,983068],[2,12,7154221],[3,12,9522185],[4,12,1314568],[6,12,131586],[7,12,921102],[8,12,1710618],[9,12,1513239],[10,12,657930],[13,12,2892051],[14,12,12610067],[15,12,7220009],[16,12,196614],[1,13,3936052],[2,13,5908749],[3,13,1773570],[4,13,4402968],[5,13,10714191],[6,13,12884326],[7,13,14396274],[8,13,15053429],[9,13,14790257],[10,13,13935206],[11,13,12159571],[12,13,9265971],[13,13,2759432],[14,13,2561537],[15,13,8601360],[16,13,3346464],[1,14,3938326],[2,14,5712395],[3,14,10900499],[4,14,11951126],[5,14,11490833],[6,14,11358991],[7,14,11227662],[8,14,11161870],[9,14,11030286],[10,14,10964497],[11,14,10898963],[12,14,10833429],[13,14,11096344],[14,14,8797973],[15,14,4595726],[16,14,4594459],[17,14,327941],[1,15,2296596],[2,15,3280925],[3,15,2821148],[4,15,2624284],[5,15,2558749],[6,15,2624031],[7,15,2558496],[8,15,2558498],[9,15,2492705],[10,15,2361630],[11,15,2361374],[12,15,2295839],[13,15,2295840],[14,15,2427171],[15,15,2624036],[16,15,1377300]];
        }
        // registration faces and types
        public function register(type:String=null,facecount:int=0,url:String=""):void
        {
            if (type != null && facecount != 0) {
                Stats.aTypes.push({type:type,facecount:facecount,url:(url == "")? "internal" : url});
                Stats.totalFaces += facecount;
                Stats.meshes += 1;
            }
            Stats.geomLastAdded = " - "+type+" , faces: "+facecount+", url: "+url+"\n";
        }
        
        private function get lastRegister():String
        {
            var last:String = Stats.geomLastAdded;
            Stats.geomLastAdded = "";
            return last;
        }

        public function get stats():String
        {
            var stats:String= "";
            for (var i:int = 0;i<Stats.aTypes.length;i++){
                stats += " - "+Stats.aTypes[i].type+" , faces: "+Stats.aTypes[i].facecount+", url: "+Stats.aTypes[i].url+"\n";
            }
            Stats.geomLastAdded = "";
            return stats;
        }
        // not implemented yet
        private function generateClipBoardInfo():void{
            var strReport:String = "-- AWAY3D STATS REPORT --\n\n";
            strReport+= "GEOMETRY:\n";
            strReport+= stats ;
            strReport+= "\nCAMERA:\n";
            var camera:Camera3D = Stats.scopeMenu.camera; 
            //System.setClipboard(strReport);
        }
    }
}